<?php

namespace Drupal\mustache\Plugin;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * The plugin manager of Mustache magic variables.
 */
class MustacheMagicManager extends DefaultPluginManager {

  /**
   * The MustacheMagicManager constructor.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/mustache/Magic', $namespaces, $module_handler, 'Drupal\mustache\Plugin\MustacheMagicInterface', 'Drupal\mustache\Annotation\MustacheMagic');
    $this->alterInfo('mustache_magic_plugin');
    $this->setCacheBackend($cache_backend, 'mustache_magic_plugin');
  }

}
